<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>discover: /home/pere/src/debiancvs/pkg-discover/discover/trunk/lib/url-xml.c Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.4.2 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="annotated.html">Data&nbsp;Structures</a> | <a class="qindex" href="dirs.html">Directories</a> | <a class="qindex" href="files.html">File&nbsp;List</a> | <a class="qindex" href="functions.html">Data&nbsp;Fields</a> | <a class="qindex" href="globals.html">Globals</a></div>
<div class="nav">
<a class="el" href="dir_000002.html">lib</a></div>
<h1>url-xml.c</h1><a href="url-xml_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment">00001 
00010 <span class="comment">/* $Progeny$</span>
00011 <span class="comment"> *</span>
00012 <span class="comment"> * AUTHOR: John R. Daily &lt;jdaily@progeny.com&gt;</span>
00013 <span class="comment"> *</span>
00014 <span class="comment"> * Copyright 2002 Progeny Linux Systems, Inc.</span>
00015 <span class="comment"> * Copyright 2002 Hewlett-Packard Company</span>
00016 <span class="comment"> *</span>
00017 <span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a</span>
00018 <span class="comment"> * copy of this software and associated documentation files (the "Software"),</span>
00019 <span class="comment"> * to deal in the Software without restriction, including without limitation</span>
00020 <span class="comment"> * the rights to use, copy, modify, merge, publish, distribute, sublicense,</span>
00021 <span class="comment"> * and/or sell copies of the Software, and to permit persons to whom the</span>
00022 <span class="comment"> * Software is furnished to do so, subject to the following conditions:</span>
00023 <span class="comment"> *</span>
00024 <span class="comment"> * The above copyright notice and this permission notice shall be included in</span>
00025 <span class="comment"> * all copies or substantial portions of the Software.</span>
00026 <span class="comment"> *</span>
00027 <span class="comment"> * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
00028 <span class="comment"> * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
00029 <span class="comment"> * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL</span>
00030 <span class="comment"> * THE COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
00031 <span class="comment"> * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING</span>
00032 <span class="comment"> * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER</span>
00033 <span class="comment"> * DEALINGS IN THE SOFTWARE.</span>
00034 <span class="comment"> */</span>
00035 
00036 <span class="preprocessor">#include "config.h"</span>
00037 
00038 <span class="preprocessor">#include &lt;assert.h&gt;</span>
00039 <span class="preprocessor">#include &lt;string.h&gt;</span>
00040 
00041 <span class="preprocessor">#include &lt;expat.h&gt;</span>
00042 
00043 <span class="preprocessor">#include &lt;<a class="code" href="discover_8h.html">discover/discover.h</a>&gt;</span>
00044 <span class="preprocessor">#include &lt;<a class="code" href="discover-conf_8h.html">discover/discover-conf.h</a>&gt;</span>
00045 <span class="preprocessor">#include &lt;<a class="code" href="discover-xml_8h.html">discover/discover-xml.h</a>&gt;</span>
00046 
00047 <span class="preprocessor">#include &lt;discover/load-url.h&gt;</span>
00048 <span class="preprocessor">#include &lt;discover/url-xml.h&gt;</span>
00049 <span class="preprocessor">#include &lt;discover/utils.h&gt;</span>
00050 
<a name="l00052"></a><a class="code" href="url-xml_8c.html#a22">00052</a> <span class="keyword">enum</span> <a class="code" href="conf_8c.html#a33">state</a> { START, DISCOVER_DATA };
00053 <span class="keyword">struct </span>context {
00054     <span class="keyword">enum</span> <a class="code" href="conf_8c.html#a33">state</a> <a class="code" href="conf_8c.html#a33">state</a>;
00055 
00056     <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *urls;
00057     <span class="keywordtype">int</span> unknown_level; <span class="comment">/* How deep are we into unknown XML tags? */</span>
00058 };
00059 
00060 <span class="keyword">static</span> <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *xml_urls = NULL;
00061 <span class="keyword">static</span> <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *data_urls[<a class="code" href="group__types.html#ga14">BUS_COUNT</a>][3];
00062 
00063 <span class="keyword">static</span> <span class="keywordtype">char</span> *known_url_elements[] = {
00064     <span class="stringliteral">"location"</span>,
00065     <span class="stringliteral">"discover-data"</span>,
00066     NULL
00067 };
00068 
00069 
00070 <span class="keyword">static</span> <span class="keywordtype">bool</span>
00071 unknown_url_element(<span class="keyword">const</span> XML_Char * <span class="keyword">const</span> tag)
00072 {
00073     <span class="keywordtype">int</span> i;
00074     <span class="keywordflow">for</span> (i = 0; known_url_elements[i] != NULL; i++) {
00075         <span class="keywordflow">if</span> (strcmp(tag, known_url_elements[i]) == 0)
00076             <span class="keywordflow">return</span> <span class="keyword">false</span>;
00077     }
00078     <span class="keywordflow">return</span> <span class="keyword">true</span>;
00079 }
00080 
00081 <span class="keyword">static</span> <span class="keywordtype">void</span>
00082 add_location(<span class="keyword">struct</span> context *context, <span class="keyword">const</span> XML_Char *attrs[])
00083 {
00084     <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *<span class="keyword">new</span>;
00085     <span class="keywordtype">int</span> i;
00086 
00087     assert(context != NULL);
00088     assert(attrs != NULL);
00089 
00090     <span class="keyword">new</span> = <a class="code" href="group__url__xml.html#ga4">discover_xml_url_new</a>();
00091 
00092     <span class="keywordflow">for</span> (i = 0; attrs[i]; i += 2) {
00093         <span class="keywordflow">if</span> (strcmp(attrs[i], <span class="stringliteral">"url"</span>) == 0) {
00094             <span class="keyword">new</span>-&gt;url = _discover_xstrdup(attrs[i + 1]);
00095         } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (strcmp(attrs[i], <span class="stringliteral">"bus"</span>) == 0) {
00096             <span class="keyword">new</span>-&gt;bus = _discover_xstrdup(attrs[i + 1]);
00097         } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (strcmp(attrs[i], <span class="stringliteral">"type"</span>) == 0) {
00098             <span class="keyword">new</span>-&gt;type = _discover_xstrdup(attrs[i + 1]);
00099         }
00100     }
00101 
00102     <span class="keywordflow">if</span> (context-&gt;urls) {
00103         <span class="keywordflow">if</span> (context-&gt;urls-&gt;last) {
00104             context-&gt;urls-&gt;last-&gt;next = <span class="keyword">new</span>;
00105         } <span class="keywordflow">else</span> {
00106             context-&gt;urls-&gt;next = <span class="keyword">new</span>;
00107         }
00108         context-&gt;urls-&gt;last = <span class="keyword">new</span>;
00109     } <span class="keywordflow">else</span> {
00110         context-&gt;urls = <span class="keyword">new</span>;
00111         context-&gt;urls-&gt;next = context-&gt;urls-&gt;last = NULL;
00112     }
00113 }
00114 
00115 <span class="keyword">static</span> <span class="keywordtype">void</span>
00116 start_element(<span class="keywordtype">void</span> *ctx, <span class="keyword">const</span> XML_Char *name, <span class="keyword">const</span> XML_Char *attrs[])
00117 {
00118     <span class="keyword">struct </span>context *context = ctx;
00119 
00120     assert(context != NULL);
00121     assert(name != NULL);
00122 
00123     <span class="keywordflow">if</span> (unknown_url_element(name)) {
00124         context-&gt;unknown_level++;
00125         <span class="keywordflow">return</span>;
00126     }
00127 
00128     <span class="keywordflow">if</span> (context-&gt;unknown_level &gt; 0) {
00129         <span class="keywordflow">return</span>;
00130     }
00131 
00132     <span class="keywordflow">switch</span> (context-&gt;state) {
00133     <span class="keywordflow">case</span> START:
00134         <span class="keywordflow">if</span> (strcmp(name, <span class="stringliteral">"discover-data"</span>) == 0) {
00135             context-&gt;state = DISCOVER_DATA;
00136         }
00137         <span class="keywordflow">break</span>;
00138 
00139     <span class="keywordflow">case</span> DISCOVER_DATA:
00140         <span class="keywordflow">if</span> (strcmp(name, <span class="stringliteral">"location"</span>) == 0) {
00141             add_location(context, attrs);
00142         }
00143         <span class="keywordflow">break</span>;
00144     }
00145 }
00146 
00147 <span class="keyword">static</span> <span class="keywordtype">void</span>
00148 end_element(<span class="keywordtype">void</span> *ctx, <span class="keyword">const</span> XML_Char *name)
00149 {
00150     <span class="keyword">struct </span>context *context = ctx;
00151 
00152     assert(context != NULL);
00153     assert(name != NULL);
00154 
00155     <span class="keywordflow">if</span> (unknown_url_element(name)) {
00156         context-&gt;unknown_level--;
00157         <span class="keywordflow">return</span>;
00158     }
00159 
00160     <span class="keywordflow">if</span> (context-&gt;unknown_level &gt; 0) {
00161         <span class="keywordflow">return</span>;
00162     }
00163 
00164     <span class="comment">/*</span>
00165 <span class="comment">     * We don't have any end tags to worry about, but if we did, they</span>
00166 <span class="comment">     * would be handled here.</span>
00167 <span class="comment">     */</span>
00168 }
00169 
00181 <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *
<a name="l00182"></a><a class="code" href="group__url__xml.html#ga0">00182</a> <a class="code" href="group__url__xml.html#ga0">discover_xml_get_urls</a>(<a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00183 {
00184     <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *urls, *i;
00185     XML_Parser parser;
00186     <span class="keyword">struct </span>context context;
00187     <span class="keywordtype">int</span> loaded_urls = 0;
00188 
00189     assert(status != NULL);
00190 
00191     status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> = 0;
00192 
00193     <span class="keywordflow">if</span> (!xml_urls) {
00194         context.state = START;
00195         context.urls = NULL;
00196         context.unknown_level = 0;
00197 
00198         urls = <a class="code" href="group__conf.html#ga7">discover_conf_get_urls</a>(status);
00199         <span class="keywordflow">if</span> (status-&gt;code != 0) {
00200             <span class="keywordflow">return</span> NULL;
00201         }
00202 
00203         <span class="keywordflow">for</span> (i = urls;
00204              i;
00205              i = i-&gt;next) {
00206             parser = XML_ParserCreate(NULL);
00207             XML_SetElementHandler(parser, start_element, end_element);
00208             XML_SetUserData(parser, &amp;context);
00209 
00210             <span class="keywordflow">if</span> (_discover_load_url(i-&gt;url, parser)) {
00211                 loaded_urls++;
00212             }
00213 
00214         }
00215 
00216         <span class="keywordflow">if</span> (loaded_urls == 0) {
00217             <a class="code" href="group__url__xml.html#ga12">discover_xml_url_free</a>(context.urls);
00218             XML_ParserFree(parser);
00219             status-&gt;code = <a class="code" href="group__types.html#gga15a16">DISCOVER_EIO</a>;
00220             <span class="keywordflow">return</span> NULL;
00221         }
00222 
00223         <span class="keywordflow">if</span> (!XML_Parse(parser, <span class="stringliteral">""</span>, 0, 1)) {
00224             status-&gt;code = <a class="code" href="group__types.html#gga15a17">DISCOVER_EXML</a>;
00225         }
00226 
00227         XML_ParserFree(parser);
00228         xml_urls = context.urls;
00229 
00230         <span class="comment">/* This must be done here because there could be bogus status left</span>
00231 <span class="comment">         * over from the XML_Parse check above.  (We assume something good</span>
00232 <span class="comment">         * happened by this point.)</span>
00233 <span class="comment">         */</span>
00234         status-&gt;code = 0;
00235     }
00236 
00237     <span class="keywordflow">return</span> xml_urls;
00238 }
00239 
00243 <span class="keywordtype">void</span>
<a name="l00244"></a><a class="code" href="group__url__xml.html#ga1">00244</a> <a class="code" href="group__url__xml.html#ga1">discover_xml_free_urls</a>(<span class="keywordtype">void</span>)
00245 {
00246     <span class="keywordflow">if</span> (xml_urls) {
00247         <a class="code" href="group__url__xml.html#ga12">discover_xml_url_free</a>(xml_urls);
00248         xml_urls = NULL;
00249     }
00250 }
00251 
00260 <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *
<a name="l00261"></a><a class="code" href="group__url__xml.html#ga2">00261</a> <a class="code" href="group__url__xml.html#ga2">discover_xml_get_data_urls</a>(<a class="code" href="group__types.html#ga16">discover_bus_t</a> bus, <a class="code" href="group__types.html#ga17">discover_filetype_t</a> filetype,
00262                            <a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00263 {
00264     <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *urls, *i, *<span class="keyword">new</span>;
00265     <span class="keywordtype">char</span> *busname = <a class="code" href="group__conf.html#ga9">discover_conf_get_bus_name</a>(bus);
00266     <span class="keywordtype">char</span> *filetypename = <a class="code" href="group__conf.html#ga10">discover_conf_get_filetype_name</a>(filetype);
00267 
00268     assert(status != NULL);
00269     assert(busname != NULL);
00270 
00271     status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> = 0;
00272 
00273     <span class="keywordflow">if</span> (!data_urls[bus][filetype]) {
00274         urls = <a class="code" href="group__url__xml.html#ga0">discover_xml_get_urls</a>(status);
00275         <span class="keywordflow">if</span> (status-&gt;code != 0) {
00276             <span class="keywordflow">return</span> NULL;
00277         }
00278 
00279         status-&gt;code = <a class="code" href="group__types.html#gga15a21">DISCOVER_EDATANOTFOUND</a>;
00280         <span class="keywordflow">for</span> (i = urls;
00281              i;
00282              i = i-&gt;next) {
00283             <span class="keywordflow">if</span> (strcmp(i-&gt;bus, busname) == 0
00284                 &amp;&amp; strcmp(i-&gt;type, filetypename) == 0) {
00285 
00286                 status-&gt;code = 0;
00287 
00288                 <span class="keyword">new</span> = <a class="code" href="group__url__xml.html#ga4">discover_xml_url_new</a>();
00289                 <a class="code" href="group__url__xml.html#ga5">discover_xml_url_copy</a>(i, <span class="keyword">new</span>);
00290 
00291                 <span class="keywordflow">if</span> (data_urls[bus][filetype]) {
00292                     data_urls[bus][filetype]-&gt;last-&gt;next = <span class="keyword">new</span>;
00293                     data_urls[bus][filetype]-&gt;last = <span class="keyword">new</span>;
00294                 } <span class="keywordflow">else</span> {
00295                     data_urls[bus][filetype] = <span class="keyword">new</span>;
00296                     data_urls[bus][filetype]-&gt;last = <span class="keyword">new</span>;
00297                     data_urls[bus][filetype]-&gt;next = NULL;
00298                 }
00299             }
00300         }
00301     }
00302 
00303     <span class="keywordflow">return</span> data_urls[bus][filetype];
00304 }
00305 
00309 <span class="keywordtype">void</span>
<a name="l00310"></a><a class="code" href="group__url__xml.html#ga3">00310</a> <a class="code" href="group__url__xml.html#ga3">discover_xml_free_data_urls</a>(<span class="keywordtype">void</span>)
00311 {
00312     <span class="keywordtype">int</span> b, f;
00313 
00314     <span class="keywordflow">for</span>(b = 0; b &lt; <a class="code" href="group__types.html#ga14">BUS_COUNT</a>; b++) {
00315         <span class="keywordflow">for</span>(f = 0; f &lt; 3; f++) {
00316             <a class="code" href="group__url__xml.html#ga12">discover_xml_url_free</a>(data_urls[b][f]);
00317             data_urls[b][f] = NULL;
00318         }
00319     }
00320 }
00321 
00325 <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *
<a name="l00326"></a><a class="code" href="group__url__xml.html#ga4">00326</a> <a class="code" href="group__url__xml.html#ga4">discover_xml_url_new</a>(<span class="keywordtype">void</span>)
00327 {
00328     <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *<span class="keyword">new</span>;
00329 
00330     <span class="keyword">new</span> = _discover_xmalloc(<span class="keyword">sizeof</span>(<a class="code" href="group__types.html#ga7">discover_xml_url_t</a>));
00331 
00332     <span class="keyword">new</span>-&gt;url = NULL;
00333     <span class="keyword">new</span>-&gt;bus = NULL;
00334     <span class="keyword">new</span>-&gt;type = NULL;
00335     <span class="keyword">new</span>-&gt;label = NULL;
00336     <span class="keyword">new</span>-&gt;next = NULL;
00337     <span class="keyword">new</span>-&gt;last = NULL;
00338 
00339     <span class="keywordflow">return</span> <span class="keyword">new</span>;
00340 }
00341 
00348 <span class="keywordtype">void</span>
<a name="l00349"></a><a class="code" href="group__url__xml.html#ga5">00349</a> <a class="code" href="group__url__xml.html#ga5">discover_xml_url_copy</a>(<a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *src,
00350                       <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *dst)
00351 {
00352     assert(src != NULL);
00353     assert(dst != NULL);
00354 
00355     <span class="keywordflow">if</span> (src-&gt;url) {
00356         dst-&gt;url = _discover_xstrdup(src-&gt;url);
00357     }
00358 
00359     <span class="keywordflow">if</span> (src-&gt;bus) {
00360         dst-&gt;bus = _discover_xstrdup(src-&gt;bus);
00361     }
00362 
00363     <span class="keywordflow">if</span> (src-&gt;type) {
00364         dst-&gt;type = _discover_xstrdup(src-&gt;type);
00365     }
00366 
00367     <span class="keywordflow">if</span> (src-&gt;label) {
00368         dst-&gt;label = _discover_xstrdup(src-&gt;label);
00369     }
00370 }
00371 
00375 <span class="keywordtype">char</span> *
<a name="l00376"></a><a class="code" href="group__url__xml.html#ga6">00376</a> <a class="code" href="group__url__xml.html#ga6">discover_xml_url_get_url</a>(<a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *url)
00377 {
00378     assert(url != NULL);
00379 
00380     <span class="keywordflow">return</span> url-&gt;url;
00381 }
00382 
00386 <span class="keywordtype">char</span> *
<a name="l00387"></a><a class="code" href="group__url__xml.html#ga7">00387</a> <a class="code" href="group__url__xml.html#ga7">discover_xml_url_get_label</a>(<a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *url)
00388 {
00389     assert(url != NULL);
00390 
00391     <span class="keywordflow">return</span> url-&gt;label;
00392 }
00393 
00397 <span class="keywordtype">char</span> *
<a name="l00398"></a><a class="code" href="group__url__xml.html#ga8">00398</a> <a class="code" href="group__url__xml.html#ga8">discover_xml_url_get_bus</a>(<a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *url)
00399 {
00400     assert(url != NULL);
00401 
00402     <span class="keywordflow">return</span> url-&gt;bus;
00403 }
00404 
00408 <span class="keywordtype">char</span> *
<a name="l00409"></a><a class="code" href="group__url__xml.html#ga9">00409</a> <a class="code" href="group__url__xml.html#ga9">discover_xml_url_get_type</a>(<a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *url)
00410 {
00411     assert(url != NULL);
00412 
00413     <span class="keywordflow">return</span> url-&gt;type;
00414 }
00415 
00419 <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *
<a name="l00420"></a><a class="code" href="group__url__xml.html#ga10">00420</a> <a class="code" href="group__url__xml.html#ga10">discover_xml_url_get_next</a>(<a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *url)
00421 {
00422     assert(url != NULL);
00423 
00424     <span class="keywordflow">return</span> url-&gt;next;
00425 }
00426 
00430 <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *
<a name="l00431"></a><a class="code" href="group__url__xml.html#ga11">00431</a> <a class="code" href="group__url__xml.html#ga11">discover_xml_url_get_last</a>(<a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *url)
00432 {
00433     assert(url != NULL);
00434 
00435     <span class="keywordflow">return</span> url-&gt;last;
00436 }
00437 
00443 <span class="keywordtype">void</span>
<a name="l00444"></a><a class="code" href="group__url__xml.html#ga12">00444</a> <a class="code" href="group__url__xml.html#ga12">discover_xml_url_free</a>(<a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *urls)
00445 {
00446     <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *url, *last;
00447 
00448     last = NULL;
00449 
00450     <span class="keywordflow">for</span> (url = urls;
00451          url;
00452          url = url-&gt;next) {
00453         <span class="keywordflow">if</span> (url-&gt;url) {
00454             free(url-&gt;url);
00455         }
00456 
00457         <span class="keywordflow">if</span> (url-&gt;bus) {
00458             free(url-&gt;bus);
00459         }
00460 
00461         <span class="keywordflow">if</span> (url-&gt;type) {
00462             free(url-&gt;type);
00463         }
00464 
00465         <span class="keywordflow">if</span> (url-&gt;label) {
00466             free(url-&gt;label);
00467         }
00468 
00469         <span class="keywordflow">if</span> (last) {
00470             free(last);
00471         }
00472         last = url;
00473     }
00474 
00475     <span class="keywordflow">if</span> (last) {
00476         free(last);
00477     }
00478 }
00479 
</pre></div><hr size="1"><address style="align: right;"><small>Generated on Thu Jul 28 03:38:00 2005 for discover by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.4.2 </small></address>
</body>
</html>
